(ql:quickload :coleslaw)
(ql:quickload :hunchentoot)

(defpackage :azrazalea-net
  (:use cl)
  (:export build-coleslaw start-server stop-server deploy))

(in-package :azrazalea-net)

(defun build-coleslaw ()
  "Builds site with coleslaw. Makes the assumption that the directory the lisp image
   was started in is the site directory."
  (coleslaw:main *default-pathname-defaults*))


(let ((acceptor (make-instance 'hunchentoot:easy-acceptor :document-root (merge-pathnames "dist/") :port 4242)))
  (defun start-server ()
    "Starts a hunchentoot server that serves the site on port 4242"
    (hunchentoot:start acceptor))
  (defun stop-server ()
    "Stops a hunchentoot server that serves the site on port 4242"
    (hunchentoot:stop acceptor)))

(defun deploy ()
  (uiop:run-program "rsync -az --delete dist/ --exclude .well-known/ web-admin@azrazalea.net:www/"))
